#
# MPI Implementation
#

newMPInode <- function(rank)
    structure(list(rank = rank, RECVTAG = 33,SENDTAG = 22), class = "MPInode")

makeMPImaster <- function()
    structure(list(rank = 0, RECVTAG = 22,SENDTAG = 33), class = "MPInode")

closeNode.MPInode <- function(node) {}

sendTag.MPInode <- function(node, tag)
    #**** use string-specific version?
    mpi.send.Robj(tag, node$rank, node$SENDTAG, 0)

recvTag.MPInode <- function(node)
    #**** use string-specific version?  status arg?
    mpi.recv.Robj(node$rank, node$RECVTAG, 0)

sendData.MPInode <- function(node, data)
    mpi.send.Robj(data, node$rank, node$SENDTAG, 0)

recvData.MPInode <- function(node)
    #**** status arg?
    mpi.recv.Robj(node$rank, node$RECVTAG, 0)

makeMPIcluster <- function() {
    count <- mpi.comm.size(0) - 1
    if (count <= 0)
        stop("no nodes available.")
    cl <- vector("list",count)
    for (i in seq(along=cl))
        cl[[i]] <- newMPInode(i)
    cl
}


